package com.ynet.life.image;

import com.ynet.gene.web.dynpassword.DynamicPasswordBean;
import com.ynet.life.util.RandomGenerator;
import com.ynet.util.algorithm.RandomStringUtils;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Random;

/* loaded from: com_ynet_life_image.jar:com/ynet/life/image/VerifyImage.class */
public class VerifyImage {
    private int codeLength;
    private int defaultWidth;
    private int defaultHeight;
    private String type;
    private String code;
    private String recAct;
    private String recActDesc;
    private String recActName;
    private String recActNameDesc;
    private String amount;
    private String amountDesc;
    private HashSet positionSet;

    public void setRecActDesc(String recActDesc) {
        this.recActDesc = recActDesc;
    }

    public void setRecActNameDesc(String recActNameDesc) {
        this.recActNameDesc = recActNameDesc;
    }

    public void setAmountDesc(String amountDesc) {
        this.amountDesc = amountDesc;
    }

    public VerifyImage(String recAct, String recActName, String amount, String type, int codeLength) {
        this.codeLength = 4;
        this.defaultWidth = 500;
        this.defaultHeight = 130;
        this.type = "1";
        this.recActDesc = "收款账号: ";
        this.recActNameDesc = "收款账户名称: ";
        this.amountDesc = "交易金额: ";
        this.codeLength = codeLength;
        this.recAct = recAct;
        this.recActName = recActName;
        this.amount = amount;
        this.type = type;
        if (recAct != null) {
            init(recAct, this.codeLength);
        }
    }

    public VerifyImage(String recAct, String recActName, String amount, String type) {
        this.codeLength = 4;
        this.defaultWidth = 500;
        this.defaultHeight = 130;
        this.type = "1";
        this.recActDesc = "收款账号: ";
        this.recActNameDesc = "收款账户名称: ";
        this.amountDesc = "交易金额: ";
        this.recAct = recAct;
        this.recActName = recActName;
        this.amount = amount;
        this.type = type;
        if (recAct != null) {
            init(recAct, this.codeLength);
        }
    }

    public VerifyImage(String recAct, String recActDesc, String recActName, String recActNameDesc, String amount, String amountDesc, String type, int codeLength) {
        this.codeLength = 4;
        this.defaultWidth = 500;
        this.defaultHeight = 130;
        this.type = "1";
        this.recActDesc = "收款账号: ";
        this.recActNameDesc = "收款账户名称: ";
        this.amountDesc = "交易金额: ";
        this.codeLength = codeLength;
        this.recAct = recAct;
        this.recActDesc = recActDesc;
        this.recActName = recActName;
        this.recActNameDesc = recActNameDesc;
        this.amount = amount;
        this.amountDesc = amountDesc;
        this.type = type;
        if (recAct != null) {
            init(recAct, this.codeLength);
        }
    }

    public VerifyImage(String type) {
        this.codeLength = 4;
        this.defaultWidth = 500;
        this.defaultHeight = 130;
        this.type = "1";
        this.recActDesc = "收款账号: ";
        this.recActNameDesc = "收款账户名称: ";
        this.amountDesc = "交易金额: ";
        this.type = type;
    }

    private void init(String recAct, int length) {
        Integer[] codePosition = RandomGenerator.getCodePositions(recAct, 0, this.codeLength);
        this.positionSet = new HashSet(Arrays.asList(codePosition));
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < length; i++) {
            sb.append(recAct.charAt(codePosition[i].intValue()));
        }
        this.code = sb.toString();
    }

    public BufferedImage getImage(int width, int height) {
        int aWidth = width;
        int aHeight = height;
        if (width == 0) {
            aWidth = this.defaultWidth;
        }
        if (height == 0) {
            aHeight = this.defaultHeight;
        }
        BufferedImage image = null;
        if ("1".equals(this.type)) {
            init(this.recAct, this.codeLength);
            image = getTranImage(aWidth, aHeight);
        } else if ("0".equals(this.type)) {
            image = getSimpleImage(aWidth, aHeight);
        }
        return image;
    }

    public BufferedImage getTranImage(int width, int height) {
        ImageGenerator genenrator = new ImageGenerator(width, height);
        String colorStr = RandomStringUtils.random(1, "0-3", "");
        String colorName = "";
        if ("0".equals(colorStr)) {
            colorName = "粉色";
        } else if ("1".equals(colorStr)) {
            colorName = "红色";
        } else if ("2".equals(colorStr)) {
            colorName = "蓝色";
        } else if ("3".equals(colorStr)) {
            colorName = "绿色";
        }
        genenrator.addLine(this.recActNameDesc, this.recActName, false, null, "", false, "");
        genenrator.addLine("验证码: 请输入账号中", colorName, false, null, colorStr, true, "大号字体的数字");
        genenrator.addLine(this.recActDesc, this.recAct, true, this.positionSet, colorStr, false, "");
        genenrator.addLine(this.amountDesc, this.amount, false, null, colorStr, false, "");
        return genenrator.getImage();
    }

    public BufferedImage getSimpleImage(int width, int height) {
        BufferedImage bufferedImage = new BufferedImage(width, height, 1);
        Graphics2D graphics = bufferedImage.getGraphics();
        try {
            if (graphics instanceof Graphics2D) {
                graphics.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
                graphics.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
                graphics.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
            }
        } catch (LinkageError unused) {
        }
        graphics.setColor(new Color(220, 238, 252));
        graphics.fillRect(0, 0, width, height);
        Font[] fonts = new Font[4];
        for (int i = 0; i < 4; i++) {
            fonts[0] = new Font((String) null, 1, height - 2);
        }
        Random random = new Random();
        for (int i2 = 0; i2 < 50; i2++) {
            graphics.setColor(getRandColor(120, 160, random));
            int x = random.nextInt(width);
            int y = random.nextInt(height);
            int xl = random.nextInt(10);
            int yl = random.nextInt(10);
            graphics.drawLine(x, y, x + xl, y + yl);
        }
        int swing = 2 + random.nextInt(1);
        DynamicPasswordBean bean = new DynamicPasswordBean();
        String certifyPin = bean.generateCertifyPin(4, "23456789abcdefghijkmnpqrstuvwxyz");
        for (int i3 = 0; i3 < 4; i3++) {
            char c = certifyPin.charAt(i3);
            graphics.setColor(new Color(100 + random.nextInt(100), 30 + random.nextInt(60), 30 + random.nextInt(60)));
            graphics.setFont(fonts[i3]);
            FontMetrics fm = graphics.getFontMetrics();
            int t = ((width / 4) - fm.charWidth(c)) - (2 * swing);
            graphics.drawString(new StringBuilder(String.valueOf(c)).toString(), ((width * i3) / 4) + swing + random.nextInt(t > 0 ? t : 1), height - fm.getDescent());
        }
        double hpix = height;
        double xpix = random.nextInt() / 4.0d;
        for (int i4 = 0; i4 < height; i4++) {
            int mpix = (int) (swing * Math.sin((((i4 << 1) / hpix) + xpix) * 3.141592653589793d));
            if (mpix > 0) {
                for (int j = (width - mpix) - 1; j >= 0; j--) {
                    int rgb = bufferedImage.getRGB(j, i4);
                    bufferedImage.setRGB(j + mpix, i4, rgb);
                }
            } else if (mpix < 0) {
                for (int j2 = 0 - mpix; j2 < width; j2++) {
                    int rgb2 = bufferedImage.getRGB(j2, i4);
                    bufferedImage.setRGB(j2 + mpix, i4, rgb2);
                }
            }
        }
        this.code = certifyPin;
        return bufferedImage;
    }

    private Color getRandColor(int fc, int bc, Random random) {
        if (fc > 255) {
            fc = 255;
        }
        if (bc > 255) {
            bc = 255;
        }
        int r = fc + random.nextInt(bc - fc);
        int g = fc + random.nextInt(bc - fc);
        int b = fc + random.nextInt(bc - fc);
        return new Color(r, g, b);
    }

    public String getCode() {
        return this.code;
    }

    public void setRecAct(String recAct) {
        this.recAct = recAct;
    }

    public void setRecActName(String recActName) {
        this.recActName = recActName;
    }

    public void setAmount(String amount) {
        this.amount = amount;
    }
}
